<template>
  <div :class="{'notification-container': true, visible: notifications.length > 0}" ref="container">
    <Notification 
      v-for="(notification, i) in notifications"
      :style="{
        transition: `transform ${notification.status !== 0 ? notification.speed / 1000 : 0}s ease-in`,
        transform: `translateY(${calculateOffset(notification.status)})`,
        'z-index': 100000 - i // max-sim notifs
      }"
      :id="notification.id" 
      :message="notification.message" 
      :type="notification.type" 
      :light="notification.light"
      :key="notification.id" />
  </div>
</template>

<script>
import Notification from "@/components/base/Notification";

export default {
  name: "Notificationbar",
  components: {
    Notification
  },
  methods: {
    calculateOffset(state) {
      if (this.$refs.container) {
        if (this.$refs.container.clientHeight === 0) {
        return 50000 + 'px'; // just a big number to fix initial 0 height bug
        }
        if (state === 0) { // start position
          return this.$refs.container.clientHeight + 100 + 'px';
        } else if (state === 2 ) { // end position
          return this.$refs.container.clientHeight + 100 + 'px';
        } else { // stable position
          return 0;
        }
      } else {
        return 0;
      }
    }
  },
  computed: {
    notifications() {
      return this.$store.getters['notifications/getNotifications'];
    },
    height() {
      if (this.$refs.container) {
        return this.$refs.container.clientHeight;
      }
      return 0;
    }
  }
}
</script>

<style lang="stylus" scoped>
@import "~assets/styles/variables" 

.notification-container
  position fixed
  z-index 100
  display flex
  flex-direction column-reverse
  bottom 0
  left 0
  color $white
  width max-content
  padding 2.5rem 3rem
  transform translateY(0)
  visibility hidden
  & > *:not(:first-child)
    margin-bottom 1rem
  @media only screen and (max-width: 500px)
    width 100%

.visible
  visibility visible

.notification-start
  transform translateY(100%)

.notification-end
  transform translateY(100%)
</style>

